<?php
/**
 * @author     Corebyte Teknoloji <https://www.corebyte.tech>
 * @copyright  Corebyte Teknoloji
 * @license    http://www.gnu.org/licenses/gpl.html GNU General Public License (GPL v3)
 * @version    1.0.0
 * @usage      YOUR_DOMAIN/index.php?route=extension/module/buy_sell_margin_adjustment/cron
 */
class ControllerExtensionModuleBuysellmarginadjustment extends Controller
{
    public function cron()
    {
        // get currency rates
        $reference_data = file_get_contents("https://finans.truncgil.com/today.json");
        $reference_data = json_decode($reference_data, true);
        // site currency
        $site_currency_code = strtoupper($this->config->get('config_currency'));

        $data = $this->db->query("select * from " . DB_PREFIX . "buy_sell_margins")->rows;
        foreach ($data as $key => $value) {
            $product_id = $value['product_id'];
            $purchase_currency = $value['purchase_currency'];
            $purchase_price = $value['purchase_price'];
            $percentage_profit = $value['percentage_profit'];
            if ($site_currency_code != "TRY") {
                $rate_to = str_replace(",", ".", $reference_data[$site_currency_code]['Satış']);
            } else {
                $rate_to = 1;
            }
            if ($purchase_currency == "TRY") {
                $rate_from = 1;
            } else {
                $rate_from = str_replace(",", ".", $reference_data[$purchase_currency]['Satış']);
            }
            if ($rate_to > 0 && $rate_from > 0) {
                $converted_price = round(($purchase_price * $rate_from / $rate_to), 4);
                $sell_price = round(($converted_price * (1 + $percentage_profit / 100)), 4);
                if ($sell_price > 0) {
                    $this->db->query("UPDATE " . DB_PREFIX . "product SET price = '" . $sell_price . "' WHERE product_id = '" . $product_id . "'");
                }
            }
        }
        $this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode(["result" => "success"]));
    }
}